/*
 * Copyright (C) 2003-2007 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");


function init() {
    var fnblConfig = Components.classes["@mozilla.org/funambol/config;1"].getService(Components.interfaces.fnblConfig);
    document.getElementById("contactCheck").disabled = !getContactSync(fnblConfig);
	document.getElementById("eventCheck").disabled = !getEventSync(fnblConfig);
	document.getElementById("taskCheck").disabled = !getTaskSync(fnblConfig);
}

/*
 * Called when the "Recover" button was pressed
 */
function doRecover() {
	
	var fnblComponent = Components.interfaces.fnblComponent;
    window.opener.recover = false;
    
	if(!document.getElementById("contactCheck").checked && 
	   !document.getElementById("eventCheck").checked && 
	   !document.getElementById("taskCheck").checked) {  
		alert("Select the items to recover!!");
		return false;
	}
	
	var fnblConfig = Components.classes["@mozilla.org/funambol/config;1"].getService(Components.interfaces.fnblConfig);
    // Save current sync options
	fnblConfig.contactRestore = fnblConfig.contactSync;
	fnblConfig.eventRestore = fnblConfig.eventSync;
	fnblConfig.taskRestore = fnblConfig.taskSync;
	
	fnblConfig.contactSync = document.getElementById("contactCheck").checked;
	fnblConfig.eventSync = document.getElementById("eventCheck").checked;
	fnblConfig.taskSync = document.getElementById("taskCheck").checked;
	
	fnblConfig.save();
	
    if(document.getElementById("syncFrom").selectedIndex == 0) {
        window.opener.recover = true;
   		window.opener.recoverMode = fnblComponent.REFRESH_FROM_CLIENT;
	}
	else if(document.getElementById("syncFrom").selectedIndex == 1) {
		if (!confirm("A refresh sync from server has been requested. All the local items will be deleted before adding the server items. Are you sure you want to continue?")) {
			return false;
   		}
   		window.opener.recover = true;
   		window.opener.recoverMode = fnblComponent.REFRESH_FROM_SERVER;
	}
	return true;
}

function getContactSync(config) {
    return Components.classes["@mozilla.org/addressbook;1"] && config.contactSync && config.contactFolder != "";
}
function getEventSync(config) {
    return config.eventSync && getCalendarSync(config);
}
function getTaskSync(config) {
    return config.taskSync && getCalendarSync(config);
}
function getCalendarSync(config) {
    var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
	var cal = em.getItemForID("{e2fda1a4-762b-4020-b5ad-a41df1933103}");
	var calVersion = 0;
	
	if(cal) {
		calVersion = em.getItemForID("{e2fda1a4-762b-4020-b5ad-a41df1933103}").version;
    }
    return Components.classes["@mozilla.org/calendar/manager;1"] && calVersion.substring(0, 3) == "0.9" && config.calendarFolder != "";
}